"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var app = require("tns-core-modules/application");
var SnapKitAppDelegate = /** @class */ (function (_super) {
    __extends(SnapKitAppDelegate, _super);
    function SnapKitAppDelegate() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    SnapKitAppDelegate.prototype.applicationOpenURLOptions = function (application, url, options) {
        return SCSDKLoginClient.applicationOpenURLOptions(application, url, options);
    };
    SnapKitAppDelegate.ObjCProtocols = [UIApplicationDelegate];
    return SnapKitAppDelegate;
}(UIResponder));
exports.SnapKitAppDelegate = SnapKitAppDelegate;
// play nice with any delegate functions that may have already been set,
// we expect others to do the same with ours
if (app.ios.delegate) {
    if (app.ios.delegate.applicationOpenURLOptions) {
        // call our function, then super
        var orig_1 = app.ios.delegate.applicationOpenURLOptions;
        app.ios.delegate.applicationOpenURLOptions = function (application, url, options) {
            if (SCSDKLoginClient.applicationOpenURLOptions(application, url, options)) {
                return true;
            }
            return orig_1(application, url, options);
        };
    }
    else {
        app.ios.delegate.applicationOpenURLOptions = function (application, url, options) {
            return SCSDKLoginClient.applicationOpenURLOptions(application, url, options);
        };
    }
}
else {
    app.ios.delegate = SnapKitAppDelegate;
}
function isLoggedIn(fetchUserData) {
    return new Promise(function (resolve, reject) {
        var loggedIn = SCSDKLoginClient.isUserLoggedIn;
        resolve(loggedIn);
    });
}
exports.isLoggedIn = isLoggedIn;
function login(fetchUserData) {
    return new Promise(function (resolve, reject) {
        SCSDKLoginClient.loginFromViewControllerCompletion(app.ios.rootController, function (loggedIn, error) {
            if (error) {
                reject(error.localizedDescription);
            }
            else if (!loggedIn) {
                reject();
            }
            else if (fetchUserData) {
                getUserData(resolve, reject);
            }
            else {
                resolve();
            }
        });
    });
}
exports.login = login;
function logout() {
    return new Promise(function (resolve, reject) {
        SCSDKLoginClient.unlinkCurrentSessionWithCompletion(function (loggedOut) { return resolve(loggedOut); });
    });
}
exports.logout = logout;
function getUserData(resolve, reject) {
    var query = "{me{displayName, bitmoji{avatar}, externalId}}";
    var dic = NSMutableDictionary.new();
    dic.setObjectForKey("bitmoji", "page");
    SCSDKLoginClient.fetchUserDataWithQueryVariablesSuccessFailure(query, dic, function (resources) {
        var data = resources.valueForKey("data");
        var me = data.valueForKey("me");
        var bitmoji = me.valueForKey("bitmoji");
        resolve({
            displayName: me.valueForKey("displayName"),
            externalId: me.valueForKey("externalId"),
            avatar: bitmoji.valueForKey("avatar"),
        });
    }, function (error, bool) {
        reject(error.localizedDescription);
    });
}
